## mcs 0.4.1

=== Makefile ===
include mk/rules.mk
include mk/init.mk

SUBDIRS = src

OBJECTIVE_DATA = libmcs.pc:$(LIBDIR)/pkgconfig

include mk/objective.mk

=== src/backends/Makefile ===
include ../../mk/rules.mk
include ../../mk/init.mk

SUBDIRS = default $(GCONF_BUILD) $(KCONFIG_BUILD)

include ../../mk/objective.mk

=== src/libmcs/Makefile ===
include ../../mk/rules.mk
include ../../mk/init.mk

PICLDFLAGS = $(LIBLDFLAGS)

OBJECTIVE_LIBS = libmcs$(SHARED_SUFFIX)
OBJECTIVE_SONAME_SUFFIX = 1

LIBADD += $(DYNAMIC_LD_LIBS)

CFLAGS += $(PICFLAGS) -I.. -DPLUGIN_DIR=\"${libdir}/mcs\" -DMCS_SYSCONFDIR=\"${sysconfdir}\"

SOURCES = \
	mcs_backends.c \
	mcs_handle_factory.c \
	mcs_init.c \
	mcs_list.c \
	mcs_loader.c \
	mcs_logger.c \
	mcs_util.c

OBJECTS = ${SOURCES:.c=.o}

INCLUDEDIR = ${prefix}/include/libmcs

HEADERS = mcs.h mcs_config.h

include ../../mk/objective.mk

install-posthook:
	@mv ${DESTDIR}/${LIBDIR}/libmcs$(SHARED_SUFFIX) ${DESTDIR}/${LIBDIR}/libmcs$(SHARED_SUFFIX).1.0.0
	@ln -sf libmcs$(SHARED_SUFFIX).1.0.0 \
		${DESTDIR}/${LIBDIR}/libmcs$(SHARED_SUFFIX).1
	@ln -sf libmcs$(SHARED_SUFFIX).1 \
		${DESTDIR}/${LIBDIR}/libmcs$(SHARED_SUFFIX)

=== src/backends/kconfig/Makefile ===
include ../../../mk/rules.mk
include ../../../mk/init.mk

OBJECTIVE_LIBS = libkconfig.so

LIBDIR = ${libdir}/mcs

CXXFLAGS += -fPIC -DPIC -I../.. -DPLUGIN_DIR=\"${libdir}/mcs\"

LIBADD += -lkdecore

SOURCES = kconfig.cc
OBJECTS = ${SOURCES:.cc=.o}

include ../../../mk/objective.mk

## mcs 0.7.2

=== debian/changelog ===
mcs (0.7.2-4) unstable; urgency=low

  * QA Upload
  * Do not call make clean if buildsys.mk does not yet exist
    Closes: #724214

 -- Michael Ablassmeier <abi@debian.org>  Wed, 13 Nov 2013 00:13:29 +0100

mcs (0.7.2-3) unstable; urgency=low

  * Don't pass NULL to printf (Closes: #634879).
  * Acknowledge an NMU.
  * Orphan the package.

 -- Andrew Shadura <andrewsh@debian.org>  Wed, 10 Apr 2013 09:38:33 +0200

mcs (0.7.2-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * [libmcs-dev.preinst libmcs-utils.preinst libmcs-backend-gconf.preinst]:
    On upgrades check whether the respective entry in /usr/share/doc/ is
    a symlink and remove it.
    [libmcs1.preinst] On upgrades remove /usr/share/doc/libmcs1/html and
    /usr/share/doc/libmcs1/refman.pdf.gz which might have been placed there
    by libmcs-doc, when the broken syminks mentioned above existed.
    Closes: #696069

 -- Andreas Metzler <ametzler@debian.org>  Tue, 25 Dec 2012 15:09:59 +0100

mcs (0.7.2-2) unstable; urgency=low

  * Fix build depends on LaTeX packages needed to build the documentation
    package (Closes: #634520).

 -- Andrew O. Shadoura <bugzilla@tut.by>  Tue, 19 Jul 2011 23:23:54 +0300

mcs (0.7.2-1) unstable; urgency=low

  * New maintainer.
  * New upstream release.
  * Use dh7 and DebSrc3.0:
    - Drop dpatch.
    - Drop README.source.
    - Use dh_installdocs instead of *.links tricks.
  * debian/control:
    - Depend on autotools-dev (>= 20100122.1) which supports dh7.
    - Update Standards-Version to 3.9.2.
    - Updated the homepage.
    - Updated the descriptions of the packages.
    - Added Vcs-* fields.
    - Purged KConfig backend.
  * Ship *.symbols and *.doc-base files.
  * Link with --as-needed.
  * Don't output ANSI codes during the build process.
  * Ship doxygened documentation (Closes: #521010):
    - Run Doxygen on build.
    - Also depend on LaTeX/TeXLive and Ghostscript.

 -- Andrew O. Shadoura <bugzilla@tut.by>  Thu, 02 Jun 2011 13:59:21 +0300

mcs (0.7.1-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Remove dependency on kdelibs4c2a and libqt3-headers by removing
    the binary libmcs-backend-kconfig (Closes: #604317).

 -- Lisandro Damián Nicanor Pérez Meyer <perezmeyer@gmail.com>  Sun, 27 Feb 2011 18:10:49 -0300

mcs (0.7.1-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control
    - (Standards-Version): Update to 3.9.1.
    - (Depends): Add ${misc:Depends}.
    - (Section): remove inherited same fields.
  * debian/patches
    - (002): New. Define PATH_MAX when not available. Patch thanks to
      Marc Dequènes (Duck) <duck@hurdfr.org> (hurd FTBFS; Closes: #530939).
  * debian/README.source
    - New file.

 -- Jari Aalto <jari.aalto@cante.net>  Thu, 21 Oct 2010 18:29:57 +0300

mcs (0.7.1-1) unstable; urgency=low

  * New upstream release.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Mon, 02 Jun 2008 23:38:11 +0200

mcs (0.7.0-1) unstable; urgency=low

  * New upstream release.
  * Drop 000-Fix_library_soname and 002-Fix_big_link_breakage patches,
    fixed upstream.
  * Fix GConf mis-spelling.
  * Add missing ${shlibs:Depends} on mcs-utils.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Wed, 12 Mar 2008 22:40:30 +0100

mcs (0.6.0-1) unstable; urgency=low

  * New upstream release.
  * Add libmowgli-dev (>= 0.4.0) build depend.
  * Fix debian/watch (Closes: #449816).
  * debian/rules improvement (remove config.* from debdiff).
  * Move homepage to new dpkg standard field.
  * Bump Standards-Version to 3.7.3.
  * Fix manpages' whatis entry (bad SH NAME section).
  * Add 000-Fix_library_soname patch (atheme buildsystem broken).
  * Add 002-Fix_big_link_breakage patch (atheme buildsystem broken).
  * Add 001-Disable_Makefile_silent_output patch.
  * Add mcs-walk-config manpage and update the other ones.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Fri, 25 Jan 2008 22:19:49 +0100

mcs (0.4.1-2) unstable; urgency=low

  * Manual build re-schedule.

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Fri,  4 May 2007 23:31:51 +0200

mcs (0.4.1-1) unstable; urgency=low

  * Initial release (Closes: #413289).

 -- Adam Cécile (Le_Vert) <gandalf@le-vert.net>  Sun,  4 Mar 2007 00:19:08 +0100

=== debian/control ===
Source: mcs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev (>= 20100122.1), libgconf2-dev (>= 2.6.0), libmowgli-dev (>= 0.4.0), doxygen-latex, texlive-fonts-recommended, ghostscript
Standards-Version: 3.9.2
Section: libs
Homepage: http://www.atheme.org/projects/mcs
Vcs-Hg: http://hg.debian.org/hg/collab-maint/mcs
Vcs-Browser: http://hg.debian.org/hg/collab-maint/mcs/summary

Package: libmcs-utils
Section: admin
Architecture: any
Depends: libmcs1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: tools for the maintenance of the mcs system
 Modular Config System is a library and set of tools which abstract the
 storage of configuration settings away from userland applications.
 .
 This package contains a set of tools to deal with mcs managed configurations
 and the mcs system itself.

Package: libmcs-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: documentation files for libmcs1
 Modular Config System is a library and set of tools which abstract the
 storage of configuration settings away from userland applications.
 .
 This package contains the HTML and PDF documentation for the library.

Package: libmcs-dev
Section: libdevel
Architecture: any
Depends: libmcs1 (= ${binary:Version}), ${misc:Depends}
Description: development library and headers for libmcs1
 Modular Config System is a library and set of tools which abstract the
 storage of configuration settings away from userland applications.
 .
 This package contains the development library and its headers.

Package: libmcs1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libmcs-backend-gconf, libmcs-utils
Description: abstraction library to store configuration settings
 Modular Config System is a library and set of tools which abstract the
 storage of configuration settings away from userland applications.
 .
 It is hoped that by using mcs, that the applications which use it will
 generally have a more congruent feeling in regards to settings.
 .
 Highlights:
  * Cleanly implemented BSD-licenced code.
  * Simple, elegant, non-intrusive programming interface.
  * Modular design allows for third-party configuration backends to be
    implemented without any extra effort on the part of the development
    process of your products.
  * Dummy configuration backend which pretends that the configuration is
    blank.
  * Robust object-oriented design implemented as low-footprint C, mcs only
    adds a ~20KB memory footprint to your application.
  * XDG Base Directory spec compliance.
  * GConf support.
  * It's fast.
 .
 This package contains the runtime library.

Package: libmcs-backend-gconf
Architecture: any
Depends: libmcs1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: libmcs-utils
Description: GNOME GConf backend for libmcs
 Modular Config System is a library and set of tools which abstract the
 storage of configuration settings away from userland applications.
 .
 This package provides a GNOME GConf backend to store configurations.

=== debian/rules ===
#!/usr/bin/make -f

export CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

%:
	dh $@ --with=autotools-dev

override_dh_auto_configure:
	dh_auto_configure -- --sysconfdir=/etc --enable-gconf CFLAGS="$(CFLAGS)"

override_dh_auto_clean:
	[ ! -f buildsys.mk ] || dh_auto_clean

override_dh_auto_build:
	dh_auto_build
	doxygen
	rm -f doc/html/jquery.js
	$(MAKE) -C doc/latex pdf && mv doc/latex/*pdf doc

=== debian/watch ===
version=3
http://distfiles.atheme.org/libmcs-(.+)\.tgz

## mcs 1.0.1

=== Makefile ===
thisdir := .
SUBDIRS := build jay mcs monoresgen class mbas nunit20 ilasm tools tests errors docs
OVERRIDE_BARE_TARGETS = hells yeah
include build/rules.make

# Define these ourselves to that the platform checks come first

#all: platform-check profile-check all-recursive #all-local

.PHONY: all clean all-profiles clean-profiles install uninstall test run-test testcorlib

all: platform-check profile-check all-recursive

install: platform-check profile-check install-recursive #install-local

uninstall: platform-check profile-check uninstall-recursive #uninstall-local

test: platform-check profile-check test-recursive #test-local

run-test: run-test-recursive #run-test-local

run-test-ondotnet: run-test-ondotnet-recursive # run-test-ondotnet-local

clean: clean-recursive #clean-local

# fun specialty targets

all-profiles:
	$(MAKE) PROFILE=default all
	$(MAKE) PROFILE=net_2_0 all

clean-profiles:
	$(MAKE) PROFILE=default clean
	$(MAKE) PROFILE=net_2_0 clean

testcorlib:
	@cd class/corlib && $(MAKE) test run-test

# Disting. We need to override $(distdir) here.

package := mcs-$(VERSION)
top_distdir = $(dots)/$(package)
distdir = $(top_distdir)
export package

DISTFILES = \
	AUTHORS			\
	ChangeLog		\
	COPYING			\
	COPYING.LIB		\
	INSTALL.txt		\
	LICENSE			\
	LICENSE.GPL		\
	LICENSE.LGPL		\
	Makefile		\
	mkinstalldirs		\
	MIT.X11			\
	MonoIcon.png		\
	README			\
	ScalableMonoIcon.svg	\
	winexe.in

dist-pre:
	rm -rf $(package)

dist-post:
	tar cvzf $(package).tar.gz $(package)

dist-local: dist-default

dist-tarball: dist-pre dist-recursive dist-post

dist: dist-tarball
	rm -rf $(package)

# the egrep -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck:
	rm -rf InstallTest Distcheck-MCS ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	$(MAKE) dist-tarball || exit 1 ; \
	mv $(package) Distcheck-MCS ; \
	(cd Distcheck-MCS && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MCS $(package) ; \
	tar tzf $(package)/$(package).tar.gz |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.gz ; \
	tar tzf $(package).tar.gz |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |egrep -v '(makefrag|response)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

monocharge:
	chargedir=monocharge-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) install DESTDIR="$$DESTDIR" || exit 1 ; \
	tar cvzf "$$chargedir".tgz "$$chargedir" ; \
	rm -rf "$$chargedir"

# A bare-bones monocharge.

monocharge-lite:
	chargedir=monocharge-lite-`date -u +%Y%m%d` ; \
	mkdir "$$chargedir" ; \
	DESTDIR=`cd "$$chargedir" && pwd` ; \
	$(MAKE) -C mcs install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/corlib install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/System.XML install DESTDIR="$$DESTDIR" || exit 1; \
	$(MAKE) -C class/Mono.CSharp.Debugger install DESTDIR="$$DESTDIR" || exit 1; \
	tar cvzf "$$chargedir".tgz "$$chargedir" ; \
	rm -rf "$$chargedir"

=== btests/Makefile ===
thisdir = btests
SUBDIRS = 
TEST_RUNTIME = mono
COMPILER_FLAGS = /libpath:../class/lib/default/ /imports:System
INTERNAL_MBAS = $(TEST_RUNTIME) --debug ../mbas/mbas.exe --stacktrace $(COMPILER_FLAGS)
#INTERNAL_MBAS = vbc $(COMPILER_FLAGS)
all: test-compiler-jit 

# removed this cause INTERNAL_MBAS now getting set in 
# rules.make which is conflicting with this instance of 
# INTERNAL_MBAS
#include ../build/rules.make

DISTFILES = README.tests $(wildcard *.vb)

# We don't want debugging info :-)
USE_MCS_FLAGS :=

# include the test cases source file
include Test.Sources

# A test is a 'no pass' if it fails on either windows or linux

#TEST_NOPASS = \

all-local install-local:

# compilation is part of the testing too, so we don't actually 
# do anything in test-local.

test-local: 


run-test-local: test-compiler-jit 


test-compiler-jit: test-compiler-jit-real test-compiler-jit-ngtive_compile \
test-compiler-jit-ngtive_run


test-compiler-jit-real:
	@rm -f *.exe *.out ; \
	/bin/echo "********** Positive Tests ************" > results.out; \
	/bin/echo "********** Positive Tests ************" ; \
	for i in $(TEST_SOURCES) ; do \
		/bin/echo -n -e "========================\n$$i: " >> results.out; \
	    /bin/echo -n "$$i: "; \
	    if $(INTERNAL_MBAS) $$i.vb 1>output ; then \
            /bin/echo -n "COMPILED OK : " >> results.out; \
	        /bin/echo -n "COMPILED OK : " ;\
			true ; \
	    else \
			/bin/echo -n -e "FAILED COMPILATION\n---\n" >> results.out; \
			cat output >> results.out; \
	        /bin/echo FAILED COMPILATION ;  \
			continue;\
	    fi ; \
	    if $(TEST_RUNTIME) ./$$i.exe 1>output ; then \
			/bin/echo "EXECUTED OK" >> results.out; \
	        /bin/echo "EXECUTED OK" ; \
	    else \
			/bin/echo -n -e "$$i : FAILED AT RUNTIME\n---\n" >> results.out; \
			cat output >> results.out; \
	        /bin/echo "FAILED AT RUNTIME"; \
	    fi ; \
	    rm -f ./$$i.exe output; \
	done; \
	/bin/echo "========================" >> results.out

test-compiler-jit-ngtive_compile:
	@rm -f *.exe ; \
	/bin/echo "********** Negative Compilation Tests ************" >> results.out; \
	/bin/echo "********** Negative Compilation Tests ************" ; \
	for i in $(TEST_NGTIVE_COMPILATION_SOURCES) ; do \
		/bin/echo -n -e "========================\n$$i: " >> results.out; \
		/bin/echo -n "$$i: "; \
	    if $(INTERNAL_MBAS) $$i.vb > /dev/null ; then \
			/bin/echo "UNEXPECTED BEHAVIOUR" >> results.out; \
	        /bin/echo UNEXPECTED BEHAVIOUR ; \
	    else \
			/bin/echo OK >> results.out; \
			/bin/echo OK; \
	        continue;\
	    fi ; \
	    rm -f ./$$i.exe output; \
	done

test-compiler-jit-ngtive_run:
	@rm -f *.exe; \
	/bin/echo "********** Negative Execution Tests ************" >> results.out; \
	/bin/echo "********** Negative Execution Tests ************" ; \
	for i in $(TEST_NGTIVE_RUNTIME_SOURCES) ; do \
	    /bin/echo -n "$$i: "; \
	    if $(INTERNAL_MBAS) $$i.vb 1>output ; then \
			true ; \
	    else \
			/bin/echo -n -e "\n$$i : FAILED COMPILATION\n " >> results.out; \
			cat output >> results.out; \
			/bin/echo -n -e "\n========================" >> results.out; \
	        /bin/echo FAILED COMPILATION ; \
	        continue;\
	    fi ; \
	    if $(TEST_RUNTIME) ./$$i.exe > /dev/null ; then \
			/bin/echo -n -e "\n$$i : UNEXPECTED BEHAVIOUR\n " >> results.out; \
			/bin/echo -n -e "\n========================" >> results.out; \
	        /bin/echo UNEXPECTED BEHAVIOUR ; \
	    else \
			/bin/echo OK >> results.out; \
			/bin/echo OK; \
	    fi ; \
	    rm -f ./$$i.exe output; \
	done

=== build/Makefile ===
thisdir = build
SUBDIRS = 
include ../build/rules.make

all-local install-local test-local run-test-local run-test-ondotnet-local clean-local uninstall-local:

DISTFILES = \
	README.makefiles		\
	README.platforms		\
	README.configury		\
	config-default.make		\
	executable.make			\
	library.make			\
	rules.make			\
	platforms/linux.make		\
	platforms/win32.make		\
	profiles/default.make		\
	profiles/atomic.make		\
	profiles/net_1_0.make

dist-local: dist-default
	mkdir $(distdir)/deps

=== class/Makefile ===
thisdir = class
include ../build/rules.make

MONO_POSIX = Mono.Posix
MONO_CSHARP_DEBUGGER = Mono.CSharp.Debugger

SUBDIRS = \
	corlib				\
	System				\
	I18N				\
	System.XML			\
	System				\
	System.Drawing			\
	System.EnterpriseServices	\
	Mono.Security			\
	Mono.Data.Tds			\
	System.Security			\
	System.Data			\
	Mono.GetOptions			\
	System.Web			\
	System.Web.Services		\
	System.Runtime.Serialization.Formatters.Soap \
	System.Runtime.Remoting		\
	System.Configuration.Install 	\
	System.Management		\
	$(MONO_CSHARP_DEBUGGER)         \
	Mono.Data.SqliteClient		\
	Mono.Data.SybaseClient		\
	Mono.Data.TdsClient		\
	System.Data.OracleClient	\
	$(MONO_POSIX)			\
	Accessibility			\
	Microsoft.VisualBasic		\
	Microsoft.VisualC		\
	Cscompmgd			\
	System.Windows.Forms		\
	System.Design			\
	PEAPI				\
	Npgsql				\
	ICSharpCode.SharpZipLib		\
	ByteFX.Data			\
	Commons.Xml.Relaxng		\
	Novell.Directory.Ldap		\
	Mono.Security.Win32		\
	System.DirectoryServices	\
	System.Messaging	        \
	System.ServiceProcess           \
	System.Drawing.Design		\
	Mono.Http			\
	Microsoft.Vsa			\
	Mono.Cairo                      \
	IBM.Data.DB2			     
#	Microsoft.JScript		\

# Starting with Microsoft.Vsa, the libraries above weren't in the
# Linux makefile.gnu before, but they build fine, so might as well
# include them ...
#
# Need a way to only build/test Mono.Security.Win32 on Windows.
# It builds on linux, but make run-test will barf because a
# DLL doesn't exist.

# These libraries below are either unimplemented or don't compile, but
# I wrote makefiles for them.

DIST_ONLY_SUBDIRS = \
	Custommarshalers		\
	Mono.Globalization

# No new makefiles for: System.Messaging, System.Web.Mobile,
# System.ServiceProcess

DISTFILES = \
	LICENSE 		\
	README			\
	doc/API-notes		\
	doc/NUnitGuidelines	\
	doc/notes		\
	notes/BitVecto32.txt

all-local install-local test-local run-test-local clean-local uninstall-local:

dist-local: dist-default
	-mkdir $(distdir)/lib

=== docs/Makefile ===
thisdir = docs
SUBDIRS = 
include ../build/rules.make

DISTFILES = clr-abi.txt compiler control-flow-analysis.txt order.txt

all-local install-local clean-local test-local run-test-local uninstall-local:

dist-local: dist-default

=== errors/Makefile ===
thisdir = errors
SUBDIRS = 
include ../build/rules.make

# force this, we don't case if CSC is broken. This also
# means we can use --options, yay.

MCS = $(INTERNAL_MCS)
LOCAL_MCS_FLAGS = /nowarn:162 --wlevel 4

GMCS_COMPILE = $(RUNTIME) ../gmcs/gmcs.exe /target:library $(MCS_FLAGS)

RUNTEST_PL = ./runtest.pl

DISTFILES = \
	CONTRIBUTORS_README 	\
	README.tests		\
	errors.txt 		\
	fail			\
	runtest.pl		\
	$(wildcard *.cs)

#all-local: run-test-local test-multi-local
all-local: CS0618-2-lib.dll CS0619-8-lib.dll CS0619-17-lib.dll CS0619-32-lib.dll CS0619-33-lib.dll CS0619-36-lib.dll \
CS3005-16-lib.dll CS3013-module.dll

test-local:

# again, run-test is when the tests actually happen, so
# don't compile on make test.

run-test-local: test-multi-local run-mcs-tests run-generics-local

run-mcs-tests:
	@ ./do-tests.pl mcs "$(CSCOMPILE)" "cs*.cs"

run-generics-local:
	@ ./do-tests.pl gmcs "$(GMCS_COMPILE)" "gcs*.cs"

test-multi-local:
	@ failed=false; \
	testsuite_log=test-multi.log; rm -f $$testsuite_log ; \
	for i in error-*.cs; do \
		test_out=`echo $$i | sed 's,.cs$$,.out,'` ; \
		test_log=`echo $$i | sed 's,.cs$$,.log,'` ; \
		echo -n "Running test $$i ... "; \
		$(INTERNAL_MCS) $$i > $$test_out 2>&1 || : ; \
		if $(RUNTEST_PL) $$i $$test_out > $$test_log 2>&1 ; \
		then echo OK; rm -f $$test_out $$test_log ; \
		     echo "PASS: $$i" >> $$testsuite_log ; \
		else echo FAILED; \
		     echo "FAIL: $$i" >> $$testsuite_log ; \
		     flist="$$flist $$i"; \
		     failed=true; \
		fi; \
	done; \
	if $$failed; then \
		echo "The following tests failed: $$flist"; \
		exit 1; \
	else \
		echo All tests passed; \
	fi

clean-local:
	rm -f *.exe
	rm -f *.dll
	rm -f *.log

dist-local: dist-default

install-local uninstall-local:

%-lib.dll: %-lib.cs
	$(BOOTSTRAP_MCS) /target:library /out:$@ $<

%-module.dll: %-module.cs
	$(BOOTSTRAP_MCS) /target:module /out:$@ $<

=== gmcs/Makefile ===
thisdir := gmcs
SUBDIRS := 
include ../build/rules.make

COMPILER_SOURCES = \
	AssemblyInfo.cs			\
	anonymous.cs			\
	assign.cs			\
	attribute.cs			\
	driver.cs		 	\
	cs-tokenizer.cs			\
	cfold.cs			\
	class.cs 			\
	codegen.cs			\
	const.cs			\
	constant.cs			\
	convert.cs			\
	decl.cs				\
	delegate.cs			\
	enum.cs				\
	ecore.cs			\
	expression.cs 			\
	flowanalysis.cs			\
	generic.cs			\
	iterators.cs			\
	literal.cs			\
	location.cs			\
	modifiers.cs 			\
	namespace.cs			\
	parameter.cs			\
	pending.cs			\
	report.cs			\
	rootcontext.cs			\
	statement.cs			\
	support.cs			\
	typemanager.cs			\
	symbolwriter.cs			\
	tree.cs				\
	CryptoConvert.cs

all_sources = $(COMPILER_SOURCES) cs-parser.cs

DISTFILES = \
	$(COMPILER_SOURCES)	\
	compiler.csproj		\
	compiler.doc		\
	compiler.sln		\
	cs-parser.jay		\
	mcs.exe.config		\
	NOTES			\
	TODO
#uncomment to enable some debug stuff
#DEBUG_FLAGS=/define:MCS_DEBUG

all-local: gmcs.exe

install-local: gmcs.exe
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/lib/mono/2.0
	$(INSTALL_BIN) gmcs.exe $(DESTDIR)$(prefix)/lib/mono/2.0

uninstall-local:
	-rm -f $(DESTDIR)$(prefix)/bin/mcs.exe

test-local run-test-local:

clean-local:
	rm -f *.exe *.pdb cs-parser.cs y.output

dist-local: dist-default

gmcs.exe: $(all_sources)
	MONO_PATH="../class/lib/net_2_0_bootstrap$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" mono ../mcs/mcs.exe $(DEBUG_FLAGS) -2 /target:exe /debug /out:$@ $^

gmcs2.exe: $(all_sources)
	MONO_PATH="../class/lib/net_2_0$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" time mcs -2 /target:exe /debug /out:$@ $^ $(DEBUG_FLAGS) 

gmcs3.exe: $(all_sources)
	MONO_PATH="../class/lib/net_2_0$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" time $(RUNTIME) ./gmcs2.exe $(USE_MCS_FLAGS) $(DEBUG_FLAGS) -2 /target:exe /debug /out:$@ $^

gmcs4.exe: $(all_sources)
	MONO_PATH="../class/lib/net_2_0$(PLATFORM_PATH_SEPARATOR)$$MONO_PATH" time $(RUNTIME) ./gmcs3.exe $(USE_MCS_FLAGS) $(DEBUG_FLAGS) -2 /target:exe /debug /out:$@ $^

cs-parser.cs: cs-parser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ctv < $(topdir)/jay/skeleton.cs $< > jay-tmp.out && mv jay-tmp.out $@

# Testing targets

TIME = 

# This used to be called test, but that conflicts with the global
# recursive target.

btest: gmcs2.exe gmcs3.exe gmcs4.exe
	ls -l gmcs3.exe gmcs4.exe

wc:
	wc -l $(all_sources)

ctest: 
	rm -f gmcs3.exe mcs4.exe
	make btest USE_MCS_FLAGS= 

# we need this because bash tries to use its own crappy timer
FRIENDLY_TIME = $(shell which time) -f'%U seconds'

do-time : mcs.exe
	@ echo -n "Run 1:   "
	 $(FRIENDLY_TIME) $(RUNTIME) ./mcs.exe $(USE_MCS_FLAGS) /target:exe /out:mcs2.exe $(all_sources) > /dev/null || (echo FAILED; exit 1)
	@ echo -n "Run 2:   "
	@ $(FRIENDLY_TIME) $(RUNTIME) ./mcs2.exe $(USE_MCS_FLAGS) /target:exe /out:mcs3.exe $(all_sources) > /dev/null || (echo FAILED; exit 1)
	@ echo -n "corlib:  "
	@ rm -f ../class/lib/mscorlib.dll
	@ (cd ../class/corlib ; make BOOTSTRAP_MCS="$(FRIENDLY_TIME) mono ../../mcs/mcs.exe" > /dev/null ) || (echo FAILED; exit 1)

do-corlib:
	@ echo -n "corlib:  "
	@ rm -f ../class/lib/mscorlib.dll
	@ (cd ../class/corlib ; make BOOTSTRAP_MCS="$(FRIENDLY_TIME) mono ../../mcs/mcs.exe" > /dev/null ) || (echo FAILED; exit 1)

PROFILER=default

profile : gmcs2.exe
	make gmcs3.exe RUNTIME="$(RUNTIME) --profile"

response:
	echo $(all_sources) > res

=== ilasm/Makefile ===
thisdir = ilasm
SUBDIRS =
include ../build/rules.make

PROGRAM = ilasm.exe
BUILT_SOURCES = ILParser.cs
LOCAL_MCS_FLAGS = /lib:../class/lib/default /r:PEAPI.dll

CLEAN_FILES = parser/y.output

EXTRA_DISTFILES = \
	parser/ILParser.jay	\
	parser/ChangeLog	\
	scanner/ChangeLog	\
	tests/ChangeLog		\
	$(wildcard tests/*.il)

ILParser.cs: parser/ILParser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ct < $(topdir)/jay/skeleton.cs $< >$@

include ../build/executable.make

=== jtests/Makefile ===
thisdir = jtests
SUBDIRS = 
INTERNAL_MJS = $(TEST_RUNTIME) $(topdir)/class/Microsoft.JScript/Microsoft.JScript/mjs.exe
all: test-compiler-jit
include ../build/rules.make
include Test.Sources

all-local install-local:

test-local:

run-test-local: test-compiler-jit

test-compiler-jit: test-compiler-jit-real

test-compiler-jit-real:
	@rm -f *.exe *.out; \
	/bin/echo "*** Tests ***" > results.out; \
	/bin/echo "*** Tests ***"; \
	for i in $(TEST_SOURCES) ; do \
		/bin/echo -n -e "===\n$$i: " >> results.out; \
	    /bin/echo -n "$$i: "; \
	    if $(INTERNAL_MJS) $$i.js 1>output ; then \
	    /bin/echo -n "COMPILED OK : " >> results.out; \
		/bin/echo -n "COMPILED OK : " ; \
		    true; \
	   else \
			/bin/echo -n -e "FAILED COMPILATION\n---\n" >> results.out; \
			cat output >> results.out; \
	      /bin/echo "FAILED COMPILATION" ; \
		     continue; \
	    fi ; \
	    if $(TEST_RUNTIME) ./$$i.exe 1>output ; then \
			/bin/echo "EXECUTED OK" >> results.out; \
		/bin/echo "EXECUTED OK"; \
	    else \
			/bin/echo -n -e "$$i : FAILED AT RUNTIME\n---\n" >> results.out; \
			cat output >> results.out; \
		/bin/echo "$$i : FAILED AT RUNTIME" ; \
	    fi ; \
	    rm -f ./$$i.exe output; \
	done; \
	/bin/echo "===" >> results.out

clean-local:
	rm *~

=== mbas/Makefile ===
thisdir = mbas
SUBDIRS = 
include ../build/rules.make

PROGRAM = mbas.exe
BUILT_SOURCES = mb-parser.cs

LOCAL_MCS_FLAGS = /r:System.dll /r:$(topdir)/class/lib/$(PROFILE)/Mono.GetOptions.dll

EXTRA_DISTFILES = mb-parser.jay mbas.csproj mbas.ico mbas.sln
CLEAN_FILES = y.output testmbas/WriteOK.exe

PROGRAM_INSTALL_DIR = $(prefix)/lib/mono/1.0

include ../build/executable.make

run-test-local: run-mbas-test

run-mbas-test: testmbas/WriteOK.exe
	$(TEST_RUNTIME) --debug testmbas/WriteOK.exe

mb-parser.cs: mb-parser.jay
	$(topdir)/jay/jay -ctv <$(topdir)/jay/skeleton.cs $< >$@

verbose: mbas.exe
	$(TEST_RUNTIME) ./mbas.exe --verbosegetoptions --verbose --stacktrace /libpath:../class/lib/$(PROFILE) /r:Mono.GetOptions /r:System.Data,System.Windows.Forms --main WriteOK testmbas/WriteOK.vb testmbas/WriteOK2.mbs

testmbas/WriteOK.exe: Makefile mbas.exe testmbas/*.vb testmbas/*.mbs
	$(TEST_RUNTIME) ./mbas.exe --verbosegetoptions --stacktrace /libpath:../class/lib/$(PROFILE) --reference=Mono.GetOptions -r:System.Data,System.Messaging --main WriteOK testmbas/WriteOK.vb testmbas/WriteOK2.mbs

test-aspx: mbas.exe testmbas/aspx_temp.vb
	$(TEST_RUNTIME) --debug ./mbas.exe --stacktrace --verbosegetoptions /libpath:../class/lib/$(PROFILE) /target:library /r:"System.dll" /r:"System.Xml.dll" /r:"System.Data.dll" /r:"System.Web.dll" /r:"System.Web.Services.dll" /r:"System.Drawing.dll" -- testmbas/aspx_temp.vb

=== mcs/Makefile ===
thisdir := mcs
SUBDIRS := 
include ../build/rules.make

BUILT_SOURCES = cs-parser.cs

EXTRA_DISTFILES = \
	compiler.csproj		\
	compiler.doc		\
	compiler.sln		\
	cs-parser.jay		\
	mcs.exe.config		\
	NOTES			\
	TODO

PROGRAM = mcs.exe
PROGRAM_COMPILE = $(BOOT_COMPILE)
PROGRAM_INSTALL_DIR = $(prefix)/lib/mono/1.0

CLEAN_FILES = y.output

cs-parser.cs: cs-parser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ctv < $(topdir)/jay/skeleton.cs $< > jay-tmp.out && mv jay-tmp.out $@

include ../build/executable.make

# Testing targets

TIME = time

# This used to be called test, but that conflicts with the global
# recursive target.

btest: mcs2.exe mcs3.exe
	ls -l mcs2.exe mcs3.exe

mcs2.exe: mcs.exe
	$(TIME) $(RUNTIME) ./mcs.exe $(USE_MCS_FLAGS) /target:exe /out:$@ $(BUILT_SOURCES) @$(response)

mcs3.exe: mcs2.exe
	$(TIME) $(RUNTIME) ./mcs2.exe $(USE_MCS_FLAGS) /target:exe /out:$@ $(BUILT_SOURCES) @$(response)

wc:
	wc -l $(BUILT_SOURCES) `cat $(sourcefile)`

ctest: 
	rm -f mcs2.exe mcs3.exe
	$(MAKE) USE_MCS_FLAGS= btest

# we need this because bash tries to use its own crappy timer
FRIENDLY_TIME = $(shell which time) -f'%U seconds'

do-time : mcs.exe
	@ echo -n "Run 1:   "
	@ rm -f mcs2.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs2.exe > /dev/null || (echo FAILED; exit 1)
	@ echo -n "Run 2:   "
	@ rm -f mcs3.exe
	@ $(MAKE) TIME="$(FRIENDLY_TIME)" mcs3.exe > /dev/null || (echo FAILED; exit 1)
	@ $(MAKE) do-corlib

do-corlib:
	@ echo -n "corlib:  "
	@ rm -f ../class/lib/mscorlib.dll
	@ cd ../class/corlib ; $(MAKE) BOOTSTRAP_MCS="$(FRIENDLY_TIME) mono ../../mcs/mcs.exe" > /dev/null || (echo FAILED; exit 1)

PROFILER=default

profile : mcs.exe
	$(RUNTIME) --profile=$(PROFILER) ./mcs.exe $(USE_MCS_FLAGS) /target:exe /out:mcs2.exe $(BUILT_SOURCES) @$(response)

=== monoresgen/Makefile ===
thisdir = monoresgen
SUBDIRS =
include ../build/rules.make

PROGRAM = monoresgen.exe
PROGRAM_COMPILE = $(BOOT_COMPILE)

include ../build/executable.make

## mcs 1.0.5

=== class/Makefile ===
--- 
+++ 
@@ -16,6 +16,7 @@
 	Mono.Data.Tds			\
 	System.Security			\
 	System.Data			\
+	Mono.Data			\
 	Mono.GetOptions			\
 	System.Web			\
 	System.Web.Services		\
@@ -73,9 +74,6 @@
 DISTFILES = \
 	LICENSE 		\
 	README			\
-	doc/API-notes		\
-	doc/NUnitGuidelines	\
-	doc/notes		\
 	notes/BitVecto32.txt
 
 all-local install-local test-local run-test-local clean-local uninstall-local:

=== tests/Makefile ===
#
# use `run-test-local'
#
thisdir = tests
SUBDIRS = 
include ../build/rules.make

DISTFILES = README.tests $(wildcard *.cs)

# We don't want debugging info :-)

USE_MCS_FLAGS :=

#
# If you add any tests here, please do also add them to README.Tests !
#

TEST_SOURCES = \
	test-1   test-2   test-3   test-4   test-5   test-6   test-7   test-8   test-9   test-10 \
	test-11  test-12  test-13  test-14  test-15  test-16  test-17  test-18  test-19  test-20 \
	test-21  test-22  test-23  test-24  test-25  test-26  test-27  test-28  test-29  test-30 \
	test-31  test-32  test-33  test-34  test-35  test-36  test-37  test-38  test-39  test-40 \
	test-41  test-42  test-43  test-44  test-45  test-46  test-47  test-48  test-49  	 \
	test-51  test-52  test-53  test-54  test-55  test-56  test-57  	        test-59  test-60 \
	test-61	 test-62  test-63  test-64  test-65  test-66           test-68  test-69  test-70 \
	test-71  test-72  test-73  test-74  test-75  test-76  test-77  test-78  test-79  test-80 \
	test-81  test-82  test-83  test-84  test-85  test-86  test-87  test-88  test-89  test-90 \
	test-91  test-92  test-93  test-94  test-95  test-96  test-97  test-98  test-99  test-100\
	test-101 test-102 test-103 test-104          test-106 test-107 test-108 test-109 test-110\
	test-111 test-112 test-113 test-114 test-115 test-116 test-117 test-118 test-119 	  \
	test-121 test-122 test-123          test-125 test-126 test-127 test-128 test-129 test-130 \
	test-131                   test-134 test-135 test-136 test-137 test-138 test-139 test-140 \
	test-141 test-142 test-143 test-144 test-145 test-146 test-147 test-148 test-149 test-150 \
	test-151 test-152 test-153 test-154 test-155 test-156 test-157 test-158 test-159 test-160 \
	test-161 test-162 test-163 test-164 test-165 test-166 test-167 test-168 test-169 test-170 \
		 test-172 test-173 test-174 test-175 test-176 test-177 test-178 test-179 test-180 \
	test-181 test-182 test-183 test-184 test-185 test-186 test-187 test-188 test-189 test-190 \
	test-191 test-192 test-193 test-194 test-195 test-196 test-197 test-198 test-199 test-200 \
	test-201 test-202 test-203 test-204          test-206 test-207 test-208 test-209 test-210 \
	test-211 test-212 test-213 test-214 test-215 test-216 test-217 test-218 test-219 test-220 \
	test-221 test-222 test-223 test-224 test-225 test-226 test-227          test-229 test-230 \
	test-231 test-232 test-233 test-234 test-235 test-236 test-237 test-238 test-239 test-240 \
	test-241 test-242 test-243 test-244 test-245 test-246 test-247 test-248 test-249 test-250 \
	test-251 test-252 test-253 test-254 test-255 test-256 test-257 test-258 test-259 test-260 \
	test-261 test-262 test-263 test-264 test-265 test-266 test-267 test-268 test-269 test-270 \
	test-271 test-272 test-273 test-274 test-275 test-276 test-277                   test-280 \
	                  test-283 test-284 						 test-290 \
		 test-292 \
	cls-test-0 cls-test-1 cls-test-2 cls-test-3 cls-test-5 cls-test-6 cls-test-7 cls-test-10  \
	cls-test-11 cls-test-14 cls-test-15 cls-test-16

#
# C# 2.0 tests 
#
TEST2_SOURCES = \
	2test-1 2test-2 2test-3 2test-4 2test-5 2test-6

UNSAFE_SOURCES = \
	unsafe-1 unsafe-2 unsafe-3 test-58 test-171 unsafe-5 unsafe-6 unsafe-7 unsafe-8 unsafe-9 unsafe-10

WINDOWS_SOURCES = \
	test-50 test-67

# A test is a 'no pass' if it fails on either windows or linux
# Test 120 does not pass because the MS.NET runtime is buggy.

TEST_NOPASS = \
	test-28  test-45  test-53  test-91  test-102 test-106 test-107 test-120 test-122 test-132 test-133 test-66 test-177

all-local install-local uninstall-local:

# casts

bootstrap-cast.exe: gen-cast-test.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

casts.cs: bootstrap-cast.exe
	$(RUNTIME) $< >$@

casts-mcs.exe: casts.cs
	$(CSCOMPILE) -target:exe /out:$@ $<

casts-boot.exe: casts.cs
	$(BOOT_COMPILE) -target:exe /out:$@ $<

boot-casts.out: casts-boot.exe
	$(RUNTIME) $< >$@

mcs-casts.out: casts-mcs.exe
	$(RUNTIME) $< >$@

test-casts: boot-casts.out mcs-casts.out
	cmp $^

# compilation is part of the testing too, so we don't actually 
# do anything in test-local.

test-local: 

run-test-local: test-compiler-jit test-unsafe-compiler-jit test-casts test-2

clean-local:
	rm -f *.exe *.netmodule *.out *.pdb casts.cs

dist-local: dist-default
	rm -f $(distdir)/casts.cs

test-compiler-jit: multi test-compiler-jit-real

TEST_TAG = mcs

test-compiler-jit-real:
	@rm -f *.exe $(TEST_TAG).log $(TEST_TAG)-*.log ; \
	logfile="$(TEST_TAG).log" ; \
	echo 'Running $(TEST_TAG) tests with flags "$(TEST_RUNTIME)" ... ' ; \
	for i in $(TEST_SOURCES) ; do \
	    options=`sed -n 's,^// Compiler options:,,p' $$i.cs`; \
	    testlogfile="$(TEST_TAG)-$$i.log" ; \
	    echo -n "$$i: "; \
	    echo "*** $(INTERNAL_MCS) $$options $$i.cs" > $$testlogfile ; \
	    if $(INTERNAL_MCS) $$options $$i.cs >> $$testlogfile 2>&1 ; then \
		: ; \
	    else \
		echo "Exit code: $$?" >> $$testlogfile ; \
		failed="$$failed $$i" ; \
		echo "FAIL: $$i: compilation" >> $$logfile ; \
	        echo FAILED COMPILATION ; cat $$testlogfile ; \
	    fi ; \
	    echo "*** $(TEST_RUNTIME) ./$$i.exe" >> $$testlogfile ; \
	    if $(TEST_RUNTIME) ./$$i.exe >> $$testlogfile 2>&1 ; then \
		echo "PASS: $$i" >> $$logfile ; \
	        echo OK ; rm -f $$testlogfile ; \
	    else \
		echo "Exit code: $$?" >> $$testlogfile ; \
		failed="$$failed $$i" ; \
		echo "FAIL: $$i" >> $$logfile ; \
	        echo FAILED ; cat $$testlogfile ; \
	    fi ; \
	done ; \
	if test -z "$$failed"; then :; else echo "Failing tests: $$failed"; exit 1; fi

GENERIC_KNOWN_FAILURES = test-55

# 
# Tests the generics compiler, and excludes GENERIC_KNOWN_FAILURES from the build
#
test-generic:
	sources=`echo $(TEST_SOURCES) | tr ' ' '\n' | grep -v $(GENERIC_KNOWN_FAILURES)| tr '\n' ' ' `;  \
	make INTERNAL_MCS="mono ../gmcs/gmcs.exe" test-compiler-jit-real TEST_SOURCES="$$sources" TEST_TAG=gmcs

#
# Tests the 2.0 features
#
test-2:
	make INTERNAL_MCS="mono ../mcs/mcs.exe -v2" test-compiler-jit-real TEST_SOURCES="$(TEST2_SOURCES)" TEST_TAG=mcs-v2

test-unsafe-compiler-jit:
	make INTERNAL_MCS="$(INTERNAL_MCS) /unsafe" test-compiler-jit-real TEST_SOURCES="$(UNSAFE_SOURCES)" TEST_TAG=mcs-unsafe

#
# Tests that require separate compilation
#
multi: multi-1 multi-2 multi-3 multi-5 multi-6 ilasm
	echo Multi-assembly test passes

multi-1:
	$(INTERNAL_MCS) -target:library dll-1.cs
	$(INTERNAL_MCS) -r:dll-1.dll prog-1.cs /out:prog-1.exe
	$(TEST_RUNTIME) prog-1.exe

#
# Tests that the order for internal/public in external 
# assemblies does not affect the outcome of a build.
# also checks that multiple `entry points' can be declared
# in a library. (eg, that it is not confused by two Main methods)
#
multi-2:
	$(INTERNAL_MCS) -target:library pi.cs
	$(INTERNAL_MCS) -target:library pp.cs
	$(INTERNAL_MCS) pu.cs -r:pi.dll -r:pp.dll
	$(INTERNAL_MCS) pu.cs -r:pp.dll -r:pi.dll

multi-3:
	$(INTERNAL_MCS) -target:library conv-lib.cs
	$(INTERNAL_MCS) -r:conv-lib.dll conv-main.cs
	$(TEST_RUNTIME) conv-main.exe

multi-4:
	$(INTERNAL_MCS) -target:module module-1.cs
	$(INTERNAL_MCS) -target:module module-2.cs
	$(INTERNAL_MCS) /addmodule:module-1.netmodule /addmodule:module-2.netmodule module-3.cs
	$(TEST_RUNTIME) module-3.exe

multi-5:
	$(INTERNAL_MCS) -target:library dll-2.cs
	$(INTERNAL_MCS) -r:dll-2.dll prog-2.cs /out:prog-2.exe
	$(TEST_RUNTIME) prog-2.exe

multi-6:
	$(INTERNAL_MCS) -target:library ns0.cs
	$(INTERNAL_MCS) ns.cs -r:ns0.dll

multi-7:
	$(INTERNAL_MCS) -target:library vararg-lib.cs
	$(INTERNAL_MCS) vararg-exe.cs -r:vararg-lib.dll
	$(TEST_RUNTIME) vararg-exe.exe

ilasm:
	$(INTERNAL_ILASM) /dll property-il.il
	$(INTERNAL_MCS) /r:property-il.dll property-main.cs /out:property-main.exe
	$(TEST_RUNTIME) property-main.exe
